program LiteraturVerzeichnis;

{*****************************************************************************
 *                                                                           *
 *                L i t e r a t u  r - V e r z e i c h n i s                 *
 *                              Version 1.3                                  *
 *                                                                           *
 *                        Urversion : 22.09.85                               *
 *                      3. Revision : 02.01.86                               *
 *                                                                           *
 * Dieses Programm ist ein direkter 'Abkoemmling' des Programms   'Adress-   *
 * verwaltung'  aus ' CHIP-Sonderheft:  Anwenderprogramme in Turbo-Pascal'   *
 * und kann ( bei einem 59k-System ) 1500 Eintraege verwalten.               *
 * Die Diskette mit den Daten muss sich immer in Laufwerk C: befinden, das   *
 * Programm kann sich auf einer anderen Diskette in einem anderen Laufwerk   *
 * befinden, um moeglichst viel Platz  auf der Datendiskette frei zu haben.  *
 *                                                                           *
 *                            Wolfgang Tesch                                 *
 *                                                                           *
 *****************************************************************************}

const
     Kapazitaet = 1500;
     inv  = ^F#16;
     ninv = ^F#4;
     FF = #12;
     PL = #27'C'#72;
     fett = #27'E';
     nfett = #27'F';
     lw: char = 'B';

type
    Eintrag = record
                Titel  :string[60];
                SchlagW:string[20];
                Topics :string[40];
                Quelle :string[20];
              end;

    Index = record
              IndexName : string[20];
              IndexNummer : integer
            end;

    Zeile = string[255];
    ZeichenMenge = set of char;

const
     RecZahl = 4;
     Maske : array[1..RecZahl] of record
                                    Xp,Yp : byte;
                                        M : string[80];
                                        L : byte
                                  end
             = ((Xp: 3;Yp: 3; M:'Titel / Autor : '  ;L:60 ),
                (Xp: 6;Yp: 5; M:'Schlagwort : '     ;L:20),
                (Xp: 1;Yp: 7; M:'Weitere Angaben : ';L:40),
                (Xp:10;Yp: 9; M:'Quelle : '         ;L: 20));

var
   Lit1 : Eintrag;
   Ind1 : Index;
   IndexFeld : array[1..Kapazitaet] of Index;
   IndexFile : file of Index;
   IndexGroesse,
   IndexZeiger,
   FileGroesse  : integer;
   LitFile : file of Eintrag;
   Wahl : char;
   Thema : string[30];
   NamF : text;


{$I MASKE.MOD }

procedure Status ( Meldung:Zeile;Auswahl:ZeichenMenge;var Gewaehlt:char);
  begin
    gotoxy(1,23);
    ClrEol;
    write(Meldung,' : ');
    repeat
      read(KBD,Gewaehlt);
      Gewaehlt := upcase(Gewaehlt);
    until Gewaehlt in Auswahl;
    write (Gewaehlt);
  end;

procedure SchreibLit (Lit:Eintrag;Num:integer);
  begin
    assign (LitFile,concat(lw,':Lit.DAT'));
    {$I-} reset(LitFile); {$I+}
    if IOResult <> 0 then rewrite(LitFile);
    seek(LitFile,Num-1);
    write(LitFile,Lit);
    close (LitFile);
  end;

procedure LiesLit (Num:integer;var Lit:Eintrag);
  begin
    assign (LitFile,concat(lw,':Lit.DAT'));
    {$I-}
    reset(LitFile);
    if IOResult = 0 then
      begin
        seek (LitFile,Num-1);
        if IOResult = 0 then read(LitFile,Lit);
      end;
    {$I+}
    close(LitFile);
  end;

Procedure LiesFileGroesse (var Groesse:integer);
  begin
    Groesse := 0;
    assign (LitFile,concat(lw,':Lit.DAT'));
    {$I-} reset (LitFile); {$I+}
    if IOResult = 0 then Groesse := filesize (LitFile);
    close (LitFile);
  end;

procedure LiesIndexFile (var Groesse:integer);
  begin
    Groesse := 0;
    assign (IndexFile,concat(lw,':Lit.IND'));
    {$I-} reset(IndexFile); {$I+}
    if IOResult =0 then
      while not eof(IndexFile) do
        begin
          Groesse := succ(Groesse);
          read (IndexFile,IndexFeld[Groesse]);
        end
        else
          begin
            assign(NamF,concat(lw,':LIT.NAM'));
            rewrite(NamF);
            writeln(' -!!- Neuer Datenbestand -!!-');
            write('   Thema : ');readln(Thema);
            Thema := ' '+Thema+' ';
            write(NamF,Thema);
            close(NamF);
          end;
    close (IndexFile);
  end;

procedure SchreibIndexFile (Groesse : integer);
  var Zaehler : integer;
  begin
    assign (IndexFile,concat(lw,':Lit.IND'));
    rewrite(IndexFile);
    for Zaehler := 1 to Groesse do
      write(IndexFile,IndexFeld[Zaehler]);
    close(IndexFile);
  end;

procedure MachIndex (Lit:Eintrag;Num:integer;var Ind:Index);
  begin
    Ind.IndexName:=copy(Lit.SchlagW+'                    ',1,20);
    Ind.IndexNummer := Num;
  end;

procedure SuchIndex (Ind:Index;var Zeiger:integer);
  var i,j,m : integer;
  begin
    i:=1; j:= IndexGroesse;
    repeat
      m := (i+j) div 2;
      if Ind.IndexName <= IndexFeld[m].IndexName
        then j:= m
        else i:= m+1;
    until i=j;
    Zeiger := i;
  end;

procedure SortIndex (Von,Bis : integer);
  type LIFO = ^LifoListe;
       LifoListe = record
                     v,b : integer;
                     last: LIFO;
                   end;
  var M : Index;
      i,j : integer;
      Stack : LIFO;
  procedure Push (von,bis : integer);
   var p:LIFO;
   begin
    new (p);
    p^.v := von;
    p^.b := bis;
    p^.last := Stack;
    Stack :=p;
   end;
  procedure Pop (var von,bis : integer);
   var p : LIFO;
   begin
    p := Stack;
    von := p^.v;
    bis := p^.b;
    Stack := p^.last;
    dispose (p);
   end;
  procedure Vertausche ( d1,d2 : integer);
   var temp :Index;
   begin
    temp := IndexFeld[d1];
    IndexFeld[d1] := IndexFeld[d2];
    IndexFeld[d2] := temp;
   end;
  function kleiner (x,y : Index) : boolean;
   begin
    kleiner := x.IndexName < y.IndexName;
   end;
  procedure ESort (Von,Bis : integer);
   var i,j,m : integer;
   begin
    for i:= Von to Bis-1 do
     begin
      m := i;
      for j:= i+1 to Bis do
       if kleiner(IndexFeld[j],IndexFeld[m]) then m := j;
      if m <> i then vertausche(i,m);
     end;
   end;

  begin
    Stack := nil;
    Push (Von,Bis);
    repeat
     Pop (Von,Bis);
     if Bis-Von < 7 then ESort(Von,Bis)
        else
          begin
            i := Von;
            j := Bis;
            m := IndexFeld[(i+j) div 2];
            repeat
              while kleiner (IndexFeld[i],m)  do i:=succ(i);
              while kleiner (m,IndexFeld[j]) do j := pred(j);
              if i <= j then
                begin
                  vertausche (i,j);
                  i := succ(i);
                  j := pred(j);
                end;
            until i > j ;
            if i < Bis then Push (i,Bis);
            if j > Von then Push (Von,j);
          end;
    until Stack = nil;
  end;

overlay procedure NeuEingabe;
  var Wahl : char;
  begin
    ClrScr;
    repeat
      Status('E)ingabe , Q)uit  ',['E','Q'],Wahl);
      if Wahl = 'E' then
        begin
          fillchar (Lit1,sizeof(Lit1),0);
          LiesRecord (Lit1,Maske,RecZahl);
          FileGroesse := succ (FileGroesse);
          IndexGroesse := succ(IndexGroesse);
          MachIndex (Lit1,FileGroesse,Ind1);
          IndexFeld[IndexGroesse] := Ind1;
          SchreibLit (Lit1,FileGroesse);
        end;
    until Wahl = 'Q';
    SortIndex (1,IndexGroesse);
  end;

overlay procedure  Update;
  var IndexZeiger : integer;
      Wahl,JaNein : char;
      veraendert : boolean;
      ZZ : byte;
      bereit : boolean;
  procedure Kill ( Ind : Index; var Groesse : integer);
    var i : integer;
    begin
     i := 1;
     while i <= Groesse do
      if IndexFeld[i].IndexName = Ind.IndexName then
       begin
        IndexFeld[i] := IndexFeld[Groesse];
        Groesse  := pred (Groesse);
       end
       else  i := succ(i);
    end;

  begin
     ClrScr;
     ZZ := 0;
     bereit := (( Port[4] and 15) = 10 );
     if bereit then write ( LST,PL );
     veraendert := true;
     IndexZeiger := IndexGroesse;
     repeat
       if veraendert then
         begin
           LiesLit (IndexFeld[IndexZeiger].IndexNummer,Lit1);
           SchreibRecord(Lit1,Maske,RecZahl);
           veraendert := false;
         end;
       Status ('S)uchen , V)or , Z)urueck , E)ditieren , L)oeschen ,'+
               ' H)ardcopy , Q)uit',['S','V','Z','E','L','H','Q'],Wahl);
       case Wahl of
       'H' : begin
              bereit := ((Port[4] and 15) = 10 );
              if bereit then
               begin
                ZZ := ZZ+5;
                if ZZ > 65 then
                 begin
                  write (LST,FF);
                  ZZ := 5;
                 end;
                with Lit1 do
                 begin
                  write(LST,fett,'      Titel / Autor : ',nfett);
                  writeln(LST,Titel);
                  write(LST,fett,'         Schlagwort : ',nfett);
                  writeln(LST,SchlagW);
                  write(LST,fett,'    weitere Angaben : ',nfett);
                  writeln(LST,Topics);
                  write(LST,fett,'             Quelle : ',nfett);
                  writeln(LST,Quelle);
                  writeln(LST);
                 end;
               end;
             end;

       'Z' : if IndexZeiger > 1
               then
                 begin
                   IndexZeiger := pred(IndexZeiger);
                   veraendert := true;
                 end
               else write(^G);

       'V' : if IndexZeiger < IndexGroesse
               then
                 begin
                   IndexZeiger := succ(IndexZeiger);
                   veraendert := true;
                 end
               else write(^G);

       'S' : begin
               gotoxy(1,21);
               write('Schlagwort : ');read(Lit1.SchlagW);
               gotoxy(1,21); ClrEol;
               MachIndex(Lit1,0,Ind1);
               SuchIndex(Ind1,IndexZeiger);
               veraendert := true;
             end;

       'E' : begin
               LiesRecord (Lit1,MAske,RecZahl);
               MachIndex(Lit1,IndexFeld[IndexZeiger].IndexNummer,Ind1);
               IndexFeld[IndexZeiger] := ind1;
               SchreibLit(Lit1,Ind1.IndexNummer);
               SortIndex(1,IndexGroesse);
               veraendert := true;
             end;

       'L' : begin
               gotoxy(1,21);
               write('Wirklich loeschen (J/N) ?');
               repeat
                 read(KBD,JaNein);
               until upcase(JaNein) in ['J','N'];
               if upcase(JaNein) = 'J' then
                 begin
                   MachIndex(Lit1,IndexFeld[IndexZeiger].IndexNummer,Ind1);
                   Kill(Ind1,IndexGroesse);
                   SortIndex(1,IndexGroesse);
                   veraendert := true;
                 end;
               gotoxy(1,21); ClrEol;
             end;
       end;
    until Wahl = 'Q';
    if ZZ >0 then write(LST,FF);
  end;

overlay procedure Ausgabe;
  var Wahl : char;
      i : integer;
  procedure D_Ausgabe;
  var LC : byte;
      bereit : boolean;
      Tab : String[8];
  begin
    {$U+} {Unterbrechung moeglich}
    Tab := '        ';
    bereit := ((Port[4] and 15) = 10);
    if not bereit
      then
      begin
        write(#7);
        ClrScr;
        writeln('Keine Ausgabe moeglich, da Drucker nicht bereit !');
        writeln;
        writeln('zurueck zum Hauptmenu --> RET druecken',#7);
        readln;
      end
      else
      begin
        write(LST,PL);
        writeln(LST,TAB,'Gesamtbestand des Literaturverzeichnisses',
                    ' zum Thema',fett,Thema,nfett);
        writeln(LST); writeln(LST);
        LC := 4;

        for i := 1 to Indexgroesse do
        begin
          LiesLit(IndexFeld[i].IndexNummer,Lit1);
          with Lit1 do
          begin
            writeln(LST,TAB,Titel,' (',Quelle,')');
            writeln(LST,TAB,fett,SchlagW,nfett,' , ',Topics);
            writeln(LST);
          end;{with}
          if  LC  < 65
            then Lc := LC+3
            else
            begin
              write(LST,FF);
              LC  := 1;
            end;
        end;
      end;
      {$U-} {Unterbrechung aus}
  end;

  procedure B_Ausgabe;
  var LC : byte;
  begin
    i := 1;
    Clrscr;
    LC :=1;
    while i <= Indexgroesse do
    begin
      LiesLit(IndexFeld[i].IndexNummer,Lit1);
      with Lit1 do
      begin
        writeln(Titel,' (',Quelle,')');
        writeln(inv,SchlagW,ninv,' , ',Topics);
        writeln;
      end;{with}
      if LC < 18
        then LC := LC+3
        else
        begin
          writeln;
          write('          weiter --> RET druecken '); readln;
          ClrScr;
          LC := 1;
        end; {else}
      i  := succ(i);
    end; {while}
    writeln;
    write('       zum  Hauptmenu  -->  RET druecken');
    readln;
  end;


  begin
    ClrScr;
    Status ('B)ildschirm , D)rucker ',['B','D'],Wahl);
    if Wahl = 'B'
      then B_Ausgabe
      else D_Ausgabe;
  end;


overlay procedure Packen;

{ entferne 'Karteileichen' aus dem Daten-File }

type
  Str14   = String[14];
var
  TmpFile : File of Eintrag;
  Lit     : Eintrag;
  i       : Integer;
  RamFl   : boolean;
  DPH,DPB : integer;
  Recs    : integer;
  MaxRecs : integer;
  FileNa       : Str14;

procedure FileCopy (Dest,Source : Str14);
var
  SFile,DFile : file;
  Buffer      : array[1..8,0..127] of byte;
  fertig      : integer;

begin
  assign(DFile,Dest);
  rewrite(DFile);
  assign(SFile,Source);
  reset(SFile);

  repeat
    BlockRead (SFile,Buffer,8,fertig);
    BlockWrite(DFile,Buffer,fertig);
  until fertig = 0;

  close(DFile);
  close(SFile);
end;


begin
  Clrscr;
  writeln;
  writeln('Reorganisation des Datenbestandes :');
  writeln;

  RamFl := false;
  DPH := BIOSHL(8,ord('F')-ord('A'));
  if DPH <> 0 then
    begin { Ram-Disk verfuegbar }
      DPB := 256*mem[DPH+11]+mem[DPH+10];
      MaxRecs := 8*(256*mem[DPB+6]+mem[DPB+5]);
      { max Anzahl der auf Ram-Floopy speicherbaren Records,
        Blockgroesse und Dir-Groesse schon beruecksichtigt  }
      mem[$5C] := 3; { Laufwerk C }
      FileNa := 'LIT     DAT';
      for i := 1 to 11 do
        mem[$5C+i] := ord(FileNa[i]);
      for i := 12 to 35 do mem[$5C+i] := 0;
      { Standard-FCB initialisieren }
      BDOS(35,$5C);
      Recs := 256*mem[$5C+34] + mem[$5C+33];
      { Record-Zahl von LIT.DAT }
      RamFl := MaxRecs > Recs;
      { passt File auf Ram-Disc ? }
    end;

  if RamFl
    then {RamFloppy verfuegbar und gross genug }
    begin
      writeln('Ram-Disk F wird zum Zwischenspeichern verwendet');
      BDOS(14,ord('F')-ord('A'));
    end
    else
    begin
      writeln('Diskette zum Zwischenspeichern in Laufwerk A einlegen;');
      writeln('danach <RET> druecken');
      readln;
      BDOS(13); { Reset Disk System }
    end;

  assign(TmpFile,'LIT.$$$');
  rewrite(TmpFile);
  reset(LitFile);

  for i := 1 to IndexGroesse do
  begin
    gotoxy(5,9);write('gerade behandelter Index : ',i);
    LiesLit(IndexFeld[i].IndexNummer,Lit);
    write(TmpFile,Lit);
    IndexFeld[i].IndexNummer := i;
  end;

  close(TmpFile); close(LitFile);
  erase(LitFile);
  FileCopy(concat(lw,':LIT.DAT'),'LIT.$$$');
  erase(TmpFile);
  if not RamFl then
  begin
    writeln;
    writeln;
    writeln('Programm-Diskette in Laufwerk A einlegen;');
    writeln('danach <RET> druecken');
    readln;
  end;
  BDOS(13);
  SchreibIndexFile(IndexGroesse);
  LiesFileGroesse(FileGroesse);
end;

procedure Bild;
  const P = #127;
  begin
    ClrScr;
    gotoxy(22,2);
    write(P,P,P,'                          ',P,P,P);
    gotoxy(22,3);
    write(P,P,P,'            ',P,P,P,'         ',P,P,P,P,P,P,P);
    gotoxy(22,4);
    write(P,P,P,'                          ',P,P,P);
    gotoxy(22,5);
    write(P,P,P,'            ',P,P,P,'           ',P,P,P);
    gotoxy(22,6);
    write(P,P,P,'            ',P,P,P,'           ',P,P,P);
    gotoxy(22,7);
    write(P,P,P,P,P,P,'         ',P,P,P,'           ',P,P,P);
    gotoxy(22,8);
    write(P,P,P,P,P,P,'       ',P,P,P,P,P,P,P,'         ',P,P,P,P,P);
    gotoxy(23,10);
    write('Literatur-Verzeichnis zum Thema ');
    assign (NamF,concat(lw,':LIT.NAM'));
    reset (NamF);
    read (Namf,Thema);
    close (NamF);
    gotoxy((36-(length(Thema) div 2)),12);write(INV,Thema,NINV);
  end;

begin { Hauptprogramm }
  LiesIndexFile (IndexGroesse);
  LiesFileGroesse (FileGroesse);
  repeat
    Bild;
    gotoxy(1,19);
    writeln((Kapazitaet - IndexGroesse):6,' Eintraege frei');
    writeln((Filegroesse- Indexgroesse):6,' "Karteileichen"');
    Status('N)eueingabe,U)pdate,A)usgabe,R)eorganisation,Q)uit ',
           ['N','U','A','R','Q'],Wahl);
    case Wahl of
     'N' : if IndexGroesse < Kapazitaet
             then NeuEingabe
             else write(^G);
     'U' : if IndexGroesse > 0
             then Update
             else write(^G);
     'A' : Ausgabe;
     'R' : Packen;
     end;
   until Wahl = 'Q';
   SchreibIndexFile(IndexGroesse);
 end.

