{****************************************************************************}
{*                           Maskeneingabe                                  *}
{****************************************************************************}
{ Dieser Modul besteht aus 2 Prozeduren zur Eingabe bzw. Ausgabe von Records,
     -!!- deren Komponenten lediglich aus Strings bestehen duerfen -!!-,
  ueber vordefinierte Masken.

  In dem Programmteil, in dem die Prozeduren aufgerufen werden, muessen
  definiert und gueltig sein
  -- der Record selbst
  -- die Maske, die aus einem Array [1..Anzahl der Felder des Records] besteht,
     wobei jeder Arrayeintrag aufgebaut ist als Record mit den Komponenten
            X,Y :Byte       --> Bildschirmpos,an der Aus/Eingabe beginnt
              M :String[80] --> Prompt/Meldung
              L :Byte       --> max Laenge des Eintrags (des darzustellenden
                                                                 Records !)

 Beispiel :
 Beim Aufbau einer Literaturkartei sei der Record wie folgt aufgebaut:
   Var Buch : record
                Titel : string[60];
                Autor : string[30];
                 Jahr : string[ 4]
              end;
Dann kann eine Maske hierfuer beispielsweise so aussehen :
   Const BuchMaske : array[1..3] of record
                                      x,y : byte;
                                        m : string[80];
                                        l : byte
                                    end
         = ( ( x: 1;y:3;m:'Buchtitel : '       ;l:60 ),
             ( x: 1;y:5;m:'Autor : '           ;l:30 ),
             ( x:41;y:5;m:'Erscheinungsjahr : ';l: 4 ) );

Mit so deklarierten Groessen bewirken die Aufrufe von
  SchreibRecord ( Buch , BuchMaske , 3 );
die Ausgabe eines Buch-Records nach Maskenvorgaben  bzw.
  LiesRecord ( Buch , BuchMaske , 3 );
die entsprechende Eingabe.
(-!!- Achtung -!!- : Man achte darauf, dass beim Aufruf der Prozeduren die
 jeweilige Recordvariable - also z.B. BUCH - einen definierten Wert hat;
 sonst initialisiere man z.B.  durch fillchar (Buch,sizeof(Buch),0);

-----------------------------------------------------------------------------}


procedure SchreibRecord(var UsRec,UsMask;RecEintrZahl : byte );
const IvOn  = ^F#16;
      IvOff = ^F#04;

type  AnyString = string[255];

var   Temp    : AnyString;
      i       : byte;
      Maske   : array[1..255] of record
                                  xp,yp : byte;
                                  m     : string[80];
                                  l     : Byte;
                                end
                     absolute UsMask;
      RecFeld : array[0..maxint] of byte absolute UsRec;

procedure CopyRecTemp ( x:byte );
  var i,s : integer;
  begin
    s := 0;
    for i := 1 to x-1 do
      s := s + Maske[i].l + 1;
    temp := '';
    for i := 1 to RecFeld[s] do
      temp := temp + chr(RecFeld[s+i]);
  end;


begin {SchreibRecord}
  for i := 1 to RecEintrZahl do
    with Maske[i] do
      begin
        gotoxy(xp,yp);
        write(IvOn,m,IvOff);
        CopyRecTemp(i);
        while length(temp) < l do
          temp := temp + '_';
        write(' ',temp);
      end;
end;




procedure LiesRecord ( var UsRec,UsMask;RecEintrZahl : byte );

{ Editier-Moeglichkeiten :
   <RET>,^M : Sprung ins naechste Feld,Stop nach dem letzten Feld
         ^E : Sprung ins vorherige Feld (zyklisch)
         ^X : Sprung ins naechste Feld (zyklisch)
         ^S : Cursor ein Zeichen nach links
         ^D : Cursor ein Zeichen nach rechts
         ^H : Loescht das Zeichen links vom Cursor
         ^G : Loescht das Zeichen unter dem Cursor
         ^Y : Loescht ein Feld                                           }


{$V-}
type Richtung  = ( keine,fertig,rauf,runter);
     AnyString = string[255];

var Selektor : byte;
    weiter   : Richtung;
    Temp     : AnyString;
    Maske    : array[1..255] of record
                                  xp,yp : byte;
                                  m     : string[80];
                                  l     : byte;
                                end
                      absolute UsMask;
    RecFeld  : array[0..maxint] of Byte absolute UsRec;

procedure CopyRecTemp ( x : byte );
var i,s : integer;
begin
  s := 0;
  for i := 1 to x-1 do
    s := s + Maske[i].l + 1;
  temp := '';
  for i := 1 to RecFeld[s] do
    temp := temp + chr ( RecFeld[s+i] );
end;

procedure CopyTempRec ( x : byte);
var i,s : integer;
begin
  s := 0 ;
  for i := 1 to x-1 do
    s := s + Maske[i].l + 1;
  RecFeld[s] := length (temp);
  for i := 1 to length (Temp) do
    RecFeld[s+i] := ord (Temp[i]);
end;

procedure Eingabe(Spalte,Zeile:integer;var Antwort:AnyString;
                  MaxLaenge : integer; var weiter : Richtung);
var CPos,i : integer;
    c      : char;
procedure beep;begin write(^G) end;
begin
  gotoxy ( Spalte,Zeile );
  CPos := length (Antwort) + 1;
  repeat
    gotoxy (Spalte + CPos - 1,Zeile );
    read (KBD,c);
    case c of
            ^M : weiter := fertig;
            ^E : weiter := rauf;
            ^X : weiter := runter;
            ^H : if CPos > 1
                  then
                   begin
                    CPos := pred (CPos);
                    gotoxy (Spalte + CPos -1,Zeile );
                    delete (Antwort,CPos,1);
                    write(copy(Antwort,CPos,length(Antwort)-CPos+1),'_');
                   end
                  else beep;
            ^G : if CPos > 0
                  then
                   begin
                    delete ( Antwort,CPos,1);
                    write (copy(Antwort,CPos,length(Antwort)-CPos+1),'_');
                   end
                  else beep;
            ^S : if CPos > 1 then CPos := pred(CPos) else beep;
            ^D : if CPos <= length(Antwort) then CPos := succ(CPos) else beep;
            ^Y : begin
                  gotoxy (Spalte,Zeile);
                  CPos := 0;
                  while CPos < length(Antwort) do
                   begin
                    write('_');
                    CPos := succ(CPos);
                   end;
                  Antwort := '';
                  CPos := 1;
                 end;
     #32..#126 : if length (Antwort) < MaxLaenge
                  then
                   begin
                    insert ( c,Antwort,CPos);
                    write(copy(Antwort,CPos,length(Antwort)-CPos+1));
                    CPos := succ (CPos);
                   end
                  else beep;
    end;
  until weiter <> keine
end;


begin {LiesRecord}
  Selektor := 1;
  SchreibRecord(UsRec,Maske,RecEintrZahl);
  repeat
    weiter := keine;
    CopyRecTemp (Selektor);
    with Maske[Selektor] do
      Eingabe(xp+length(m)+1,yp,Temp,l,weiter);
    CopyTempRec(Selektor);
    if weiter = rauf
      then if Selektor > 1
             then Selektor := pred (Selektor)
             else Selektor := RecEintrZahl;
    if weiter = runter
      then if Selektor < RecEintrZahl
             then Selektor := succ (Selektor)
             else Selektor := 1;
    if weiter = fertig
      then if Selektor <> RecEintrZahl
             then
               begin
                 Selektor := succ (Selektor);
                 weiter := keine ;
               end;
  until (Selektor = RecEintrZahl) and (weiter = fertig);
end;

