(*****************  MOUSE.INC  *****************
 **                                           **
 ** Routine f}r Abfrage einer Atari-Maus (ST) **
 **              am MTX Port 7                **
 **                                           **
 **    von Rudolf Gmeinwieser, Pfelling 67    **
 **        8443 Bogen             01/86       **
 **                                           **
 ***********************************************)

Procedure Mouse (Var X, Y: Byte;
                 Var M_Taste_L, M_Taste_R: Boolean);

(* X, Y: Koordinaten; M_Taste_L und M_Taste_R = true,
                      wenn Tasten gedr}ckt *)

Var Wert,
    Links, Rechts, Tief, Hoch, Taste_L, Taste_R: Byte;
    M_Links, M_Rechts, M_Tief, M_Hoch: Boolean;

Begin
    Wert := Port [7];
    Links := (Wert And 4);     Case Links Of
                                 0: M_Links := true;
                                 Else M_Links := false; End;
    Rechts := (Wert And 8);    Case Rechts Of
                                 0: M_Rechts := true;
                                 Else M_Rechts := false; End;
    Tief := (Wert And 2);      Case Tief Of
                                 0: M_Tief := true;
                                 Else M_Tief := false; End;
    Hoch := (Wert And 1);      Case Hoch Of
                                 0: M_Hoch := true;
                                 Else M_Hoch := false; End;
    Taste_L := (Wert And 16);  Case Taste_L Of
                                 0: M_Taste_L := true;
                                 Else M_Taste_L := false; End;
    Taste_R := (Wert And 32);  Case Taste_R Of
                                 0: M_Taste_R := true;
                                 Else M_Taste_R := false; End;

(* Steuerung Links/Rechts *)
    Case M_Links And M_Rechts Of (* 1 - 1 *)
      True: Begin
              Wert := Port [7];
              (* LINKS *)
              Case ((Wert And 8) = 0) And ((Wert And 4)<> 0) Of
                True: X := X-1; End;
              (* RECHTS *)
              Case ((Wert And 4) = 0) And ((Wert And 8)<> 0) Of
                True: X := X+1; End;
            End;
    End;

    Case M_Links And Not M_Rechts Of (* 1 - 0 *)
      True: Begin
              Wert := Port [7];
              (* LINKS *)
              Case ((Wert And 8)= 0) And ((Wert And 4) = 0) Of
                True: X := X-1; End;
              (* RECHTS *)
              Case ((Wert And 4)<>0) And ((Wert And 8)<> 0) Of
                True: X := X+1; End;
            End;
    End;

    Case Not M_Links And M_Rechts Of (* 0 - 1 *)
      True: Begin
              Wert := Port [7];
              (* LINKS *)
              Case ((Wert And 8)<> 0) And ((Wert And 4)<> 0) Of
                True: X := X-1; End;
              (* RECHTS *)
              Case ((Wert And 4)= 0) And ((Wert And 8)= 0) Of
                True: X := X+1; End;
            End;
    End;

(* Steuerung Hoch/Tief *)
    Case M_Hoch And M_Tief Of (* 1 - 1 *)
      True: Begin
              Wert := Port [7];
              (* TIEF *)
              Case ((Wert And 1) = 0) And ((Wert And 2) <>0) Of
                True: Y := Y-1; End;
              (* HOCH *)
              Case ((Wert And 1) <> 0) And ((Wert And 2) = 0) Of
                True: Y := Y+1; End;
            End;
    End;

    Case M_Hoch And Not M_Tief Of (* 1 - 0 *)
      True: Begin
              Wert := Port [7];
              (* TIEF *)
              Case ((Wert And 1) <> 0) And ((Wert And 2)<> 0) Of
                True: Y := Y-1; End;
              (* HOCH *)
              Case ((Wert And 1) = 0) And ((Wert And 2)= 0) Of
                True: Y := Y+1; End;
            End;
    End;

    Case Not M_Hoch And M_Tief Of (* 0 - 1 *)
      True: Begin
              Wert := Port [7];
              (* TIEF *)
              Case ((Wert And 1) = 0) And ((Wert And 2) = 0) Of
                True: Y := Y-1; End;
              (* HOCH *)
              Case ((Wert And 1) <> 0) And ((Wert And 2) <> 0) Of
                True: Y := Y+1; End;
            End;
    End;

    Case Not M_Links And Not M_Rechts And Not M_Hoch And Not M_Tief Of
      True: Begin  (* 0 - 0 - 0 - 0 *)
              Wert := Port [7];
              (* TIEF *)
              Case ((Wert And 1) <> 0) And ((Wert And 2) = 0) Of
                True: Y := Y-1; End;
              (* HOCH *)
              Case ((Wert And 1) = 0) And ((Wert And 2) <> 0) Of
                True: Y := Y+1; End;
              (* LINKS *)
              Case ((Wert And 4) = 0) And ((Wert And 8) <> 0) Of
                True: X := X-1; End;
              (* RECHTS *)
              Case ((Wert And 4) <> 0) And ((Wert And 8) = 0) Of
                True: X := X+1; End;
            End;
    End;
End;