{****************************************************************************}
{*                                NIM                                       *}
{****************************************************************************}

program nim;

  const nmax = 8;
        kmax = 15;

  type  Spieler    = (Mensch, Computer);
        NimSchale  =  array[1..nmax] of 0..kmax;

  var   n          : 2..nmax;
        Schale     : NimSchale;
        Zug        : record
                       Schale : 1..nmax;
                       Anzahl : 1..kmax
                     end;
        AnderReihe : Spieler;
        PUNKTE     : integer;
        JaNein     : char;

   procedure MachSpiel;
     var i : 1..nmax;
     begin
       randomize;
       n:=random(nmax-1)+2;
       for i:=1 to n do Schale[i]:=random(kmax)+1
     end;

   procedure ZeichneSchale(x:integer);
     var i,j : integer;
     begin
       gotoxy((x-1)*10+1,14);
       write('\-----/');
       for i:=0 to (kmax-1) div 5 do begin
         gotoxy((x-1)*10+2,13-i);
         for j:=1 to 5 do if Schale[x]>=i*5+j then write('o')
                                              else write(' ')
       end;
     end;

   procedure SpielFeld;
     var i : 1..nmax;
         j : 1..kmax;
     begin
       for i:=1 to n do begin
         ZeichneSchale(i);
         gotoxy((i-1)*10+1,15);
         write('Schale ',i);
       end
     end;

   procedure MenschenZug;
     begin
      repeat
       gotoxy(1,17); ClrEol;
       write('Ihr Zug : von Schale ');
       read(Zug.Schale);
       write(' nehmen Sie ');
       read(Zug.Anzahl); write('.');
      until (Zug.Schale<=n) and (Zug.Schale>0) and
            (Zug.Anzahl>0) and
            (Schale[Zug.Schale]-Zug.Anzahl>=0);
      Schale[Zug.Schale]:=Schale[Zug.Schale]-Zug.Anzahl
     end;

   procedure ComputerZug;
     var ZugZahl : integer;

     procedure ZufallsZug;
       begin
         repeat Zug.Schale:=random(n)+1 until Schale[Zug.Schale]>0;
         Zug.Anzahl:=random(Schale[Zug.Schale])+1
       end;

     function GewinnStellung:boolean;
       var HilfsSchale : NimSchale;
           NimZahl     : integer;
           i           : 1..nmax;
       begin
         HilfsSchale:=Schale;
         HilfsSchale[Zug.Schale]:=HilfsSchale[Zug.Schale]-Zug.Anzahl;
         NimZahl:=HilfsSchale[1];
         for i:=2 to n do NimZahl:=NimZahl xor HilfsSchale[i];
         GewinnStellung:=NimZahl=0
       end;

     begin
       ZugZahl:=0;
       Zug.Schale:=1; Zug.Anzahl:=0;
       if GewinnStellung then ZufallsZug
                         else repeat
                               ZufallsZug; ZugZahl:=ZugZahl+1;
                              until GewinnStellung or (ZugZahl>PUNKTE);
       Schale[Zug.Schale]:=Schale[Zug.Schale]-Zug.Anzahl;
       gotoxy(1,18); ClrEol;
       write('Ich nehme aus der ',Zug.Schale,'-ten Schale ',Zug.Anzahl,' weg.')
     end;

   procedure Abwechseln(var x : Spieler);
     begin
       if x=Mensch then x:=Computer else x:=Mensch
     end;

   function SpielEnde:boolean;
     var Summe, i : integer;
     begin
       Summe:=0;
       for i:=1 to n do Summe:=Summe+Schale[i];
       SpielEnde:=Summe=0
     end;

begin {Hauptprogramm}
  PUNKTE:=0;  AnderReihe:=Mensch;
  repeat
   ClrScr;
   writeln('*********':40);
   writeln('*  NIM  *':40);
   writeln('*********':40);
   MachSpiel;
   writeln('Ihre Punktzahl: ':60,PUNKTE);
   writeln('Vor uns befinden sich ',n,' Reisschalen.');
   writeln('Bei jedem Zug koennen aus einer Schale beliebig viele Reiskoerner');
   writeln('entnommen werden, mindestens jedoch eines.');
   write  ('Wer nicht mehr ziehen kann, weil alle Schalen leer sind,');
   writeln(' hat verloren.');
   SpielFeld;
   repeat
     if AnderReihe=Mensch then MenschenZug else ComputerZug;
     ZeichneSchale(Zug.Schale);
     Abwechseln(AnderReihe)
   until SpielEnde;
   gotoxy(1,20);
   if AnderReihe=Computer then begin
                                 writeln('Gratuliere, Sie haben gewonnen!');
                                 PUNKTE:=PUNKTE+5
                               end
                          else begin
                                 writeln('Sie haben leider verloren!');
                                 PUNKTE:=PUNKTE-3
                               end;
   gotoxy(1,22); write('Noch ein Spiel ? ');
   repeat read(kbd,JaNein) until JaNein in ['j','J','n','N']
  until JaNein in ['n','N']
end.
